#include <stdio.h>
#include <ctype.h>

enum OutputMode
{
    MODE_NORMAL     = 0x80,
    MODE_LOWER_CASE = 0x81,
    MODE_UPPER_CASE = 0x82,
};

extern "C" 
__declspec(dllexport)
void PrintWithControlChars( char const* str )
{
    OutputMode mode = MODE_NORMAL;

    while (unsigned char c = *str++)
    {
        if (c >= 0x80)
        {
            // control character
            switch (c)
            {
            case MODE_NORMAL:
            case MODE_LOWER_CASE:
            case MODE_UPPER_CASE:
                mode = (OutputMode)c;
                break;
            default:
                printf("<%02X>", c);
            }
        }
        else
        {
            switch (mode)
            {
            case MODE_UPPER_CASE: putchar(toupper(c)); break;
            case MODE_LOWER_CASE: putchar(tolower(c)); break;
            default: putchar(c); break;
            }
        }
    }
}

extern "C"
__declspec(dllexport)
void TestControlChars()
{
    PrintWithControlChars("Normal case,\x82 Upper case,\x81 Lower case,\x80 Normal case, \x88\n");
}
